# create the version info
execute_process(
        COMMAND git describe --abbrev=6 --dirty --always --tags
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        OUTPUT_VARIABLE INPSIGHTS_VERSION_INFO
        OUTPUT_STRIP_TRAILING_WHITESPACE
)
message("Building inPsights: ${INPSIGHTS_VERSION_INFO}")

if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Intel")
    set(INPSIGHTS_VERSION_INFO_FLAG "-DINPSIGHTS_VERSION_INFO=\\\"'${INPSIGHTS_VERSION_INFO}'\\\"")
else()
    set(INPSIGHTS_VERSION_INFO_FLAG "-DINPSIGHTS_VERSION_INFO=\"'${INPSIGHTS_VERSION_INFO}'\"")
endif()


# create the CXX compiler info
execute_process(
        COMMAND bash "-c" "${CMAKE_CXX_COMPILER} --version | head -n 1"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        OUTPUT_VARIABLE INPSIGHTS_CXX_COMPILER_INFO
        OUTPUT_STRIP_TRAILING_WHITESPACE
)

if (CMAKE_BUILD_TYPE MATCHES RELEASE)
    set(INPSIGHTS_CXX_COMPILER_INFO
            "${INPSIGHTS_CXX_COMPILER_INFO} flags: ${CMAKE_CXX_FLAGS_RELEASE}${CMAKE_CXX_FLAGS}")
elseif(CMAKE_BUILD_TYPE MATCHES DEBUG)
    set(INPSIGHTS_CXX_COMPILER_INFO
            "${INPSIGHTS_CXX_COMPILER_INFO} flags: ${CMAKE_CXX_FLAGS_DEBUG}${CMAKE_CXX_FLAGS}")
elseif(CMAKE_BUILD_TYPE MATCHES RELWITHDEBINFO)
    set(INPSIGHTS_CXX_COMPILER_INFO
            "${INPSIGHTS_CXX_COMPILER_INFO} flags: ${CMAKE_CXX_FLAGS_RELWITHDEBINFO}${CMAKE_CXX_FLAGS}")
elseif(CMAKE_BUILD_TYPE MATCHES MINSIZEREL)
    set(INPSIGHTS_CXX_COMPILER_INFO
            "${INPSIGHTS_CXX_COMPILER_INFO} flags: ${CMAKE_CXX_FLAGS_MINSIZEREL}${CMAKE_CXX_FLAGS}")
endif()

message("C++ compiler: ${INPSIGHTS_CXX_COMPILER_INFO}")
if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Intel")
    set(INPSIGHTS_CXX_COMPILER_INFO_FLAG
            "-DINPSIGHTS_CXX_COMPILER_INFO=\\\"'${INPSIGHTS_CXX_COMPILER_INFO}'\\\"")
else()
    set(INPSIGHTS_CXX_COMPILER_INFO_FLAG
            "-DINPSIGHTS_CXX_COMPILER_INFO=\"'${INPSIGHTS_CXX_COMPILER_INFO}'\"")
endif()

